#include "include/mns.h"

void rpcscan(struct in_addr);

struct node **walk_global;

const static char rpcservs[] =
   { "mountd rstatd nlockmgr status nisd ttdb autofsd" };

struct node *rpc (struct in_addr target, struct node *walk) {
  struct node *head = walk;

  walk_global = &walk;
  
  if(mns_opts & VERBOSE) stralloc(walk, "\n\tRPC Services ->");
  else stralloc(walk, "\n\tPossible RPC Vulns ->");
  rpcscan(target);

  if((head->next)->next == NULL) {
     free(head->string);
     free(head->next);
     bzero(head, sizeof (struct node));
     return head;
  } else return walk;
}

void rpcscan(struct in_addr target) {
   SAin svraddr;
   struct pmaplist *pm_head = NULL, *pm_walk = NULL;
   int sockett = RPC_ANYSOCK;
   struct timeval timeout;
   register CLIENT *client;
   struct rpcent *rpc;
   char rpcchkd[250] = { ' ', '\0' };
   
   svraddr.sin_addr = target;
   svraddr.sin_family = AF_INET;
   svraddr.sin_port = htons (PMAPPORT);
   timeout.tv_sec = TIMEOUT << 1;
   timeout.tv_usec = 0;

   signal (SIGALRM, &sighandler);
   /* cause clnttcp_create uses connect() */
   alarm (TIMEOUT << 1);

   if((client = clnttcp_create(&svraddr, PMAPPROG,
                               PMAPVERS, &sockett,
                               50, 500)) == NULL) {
      alarm(0);
      perror("clnttcp_create()");
      return;
   }
   alarm (0);

   if(clnt_call(client, PMAPPROC_DUMP, (xdrproc_t)xdr_void, NULL,
	        (xdrproc_t)xdr_pmaplist, &pm_head, timeout) != RPC_SUCCESS) {
      perror("clnt_call");
      return;
   }  

  if (pm_head == NULL) return;

  for (pm_walk = pm_head; pm_walk != NULL; pm_walk = pm_walk->pml_next) {
     if((rpc = getrpcbynumber(pm_walk->pml_map.pm_prog))) {
        if(mns_opts & VERBOSE) {
           sprintf(rpcchkd, "\n\t\t%li  v.%li  %4li %s  %-10s %s",
                   pm_walk->pml_map.pm_prog,
                   pm_walk->pml_map.pm_vers,
                   pm_walk->pml_map.pm_port,
                   (pm_walk->pml_map.pm_prot == IPPROTO_TCP) ?
                   "tcp" : "udp",
                   rpc->r_name,
                   strstr(rpcservs, rpc->r_name) ? "( vuln )" : " ");
           stralloc(*walk_global, rpcchkd);
        } else {
           if(strstr(rpcservs, rpc->r_name)) {
              if(!strstr(rpcchkd, rpc->r_name)) {
                 if(strlen(rpcchkd) + strlen(rpc->r_name) < 300) {
                    strcat(rpcchkd, rpc->r_name);
                    stralloc(*walk_global, rpc->r_name);
                    break;
                 }
              }
           }
        }
     }
  }
}
